unit options;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Stringz;

type
  TFormOptions = class(TForm)
    lblWidth: TLabel;
    EditWidth: TEdit;
    lblHeight: TLabel;
    EditHeight: TEdit;
    cmdOk: TButton;
    EditWidthC: TEdit;
    EditHeightC: TEdit;
    lblPixels: TLabel;
    lblChars: TLabel;
    cmdCancel: TButton;
    chkHires: TCheckBox;
    procedure cmdOkClick(Sender: TObject);
    procedure EditWidthCKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditHeightCKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    procedure UpdateWidth;
    procedure UpdateHeight;
  public
    { Public declarations }
  end;

var
  FormOptions: TFormOptions;

implementation

{$R *.DFM}

procedure TFormOptions.cmdOkClick(Sender: TObject);
Var
  w, h : Integer;
  s : String;
begin
  w := SafeVal ( EditWidth.Text );
  h := SafeVal ( EditHeight.Text );
  //
  s := '';
  If ( w < 0 ) Or ( w > 320 ) Then
  Begin
    s := s + 'Invalid width, must be 0-320.' + #13;
  End;
  If ( h < 0 ) Or ( h > 200 ) Then
  Begin
    s := s + 'Invalid height, must be 0-200.' + #13;
  End;
  //
  if s = '' Then
  Begin
  	Close;
  End
  Else
  Begin
    ShowMessage ( s );
  End;
end;

procedure TFormOptions.EditWidthCKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  UpdateWidth;
end;

procedure TFormOptions.UpdateWidth;
Var
  w : Integer;
Begin
  If IsNumbers ( EditWidthC.Text ) Then
  Begin
    w := SafeVal ( EditWidthC.Text );
    If ( w >= 0 ) And ( w <= 40 ) Then
    Begin
      EditWidth.Text := IntToStr ( w * 8 );
    End;
  End;
End;

procedure TFormOptions.UpdateHeight;
Var
  h : Integer;
Begin
  If IsNumbers ( EditHeightC.Text ) Then
  Begin
    h := SafeVal ( EditHeightC.Text );
    If ( h >= 0 ) And ( h <= 25 ) Then
    Begin
      EditHeight.Text := IntToStr ( h * 8 );
    End;
  End;
End;

procedure TFormOptions.EditHeightCKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  UpdateHeight;
end;

end.
